org.eclipse.viatra.query.runtime.rete.single

## Class DefaultProductionNode

- java.lang.Object
- - org.eclipse.viatra.query.runtime.rete.network.BaseNode
  - - org.eclipse.viatra.query.runtime.rete.network.StandardNode
    - - org.eclipse.viatra.query.runtime.rete.single.AbstractUniquenessEnforcerNode
      - - org.eclipse.viatra.query.runtime.rete.single.UniquenessEnforcerNode
        - - org.eclipse.viatra.query.runtime.rete.single.DefaultProductionNode

- All Implemented Interfaces:
    java.lang.Iterable<Tuple>, IGroupable, NetworkStructureChangeSensitiveNode, Node, PosetAwareReceiver, ProductionNode, Receiver, RederivableNode, Supplier, Tunnel

      public class DefaultProductionNode
      extends UniquenessEnforcerNode
      implements ProductionNode

  Default implementation of the Production node, based on UniquenessEnforcerNode
  No Instantiate:
    This class is not intended to be instantiated by clients.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected java.util.Map<java.lang.String,java.lang.Integer>` | `posMapping`

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.rete.single.UniquenessEnforcerNode

      `coreMask, currentGroup, deleteRederiveEvaluation, memory, posetComparator, posetMask, rederivableMemory`

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.rete.single.AbstractUniquenessEnforcerNode

      `identityMask, mailbox, memoryIdentityIndexer, memoryNullIndexer, nullMask, parents, specializedListeners, tupleWidth`

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.rete.network.StandardNode

      `childMailboxes, children`

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.rete.network.BaseNode

      `nodeId, reteContainer, tag, traceInfos`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DefaultProductionNode(ReteContainer reteContainer, java.util.Map<java.lang.String,java.lang.Integer> posMapping, boolean deleteRederiveEvaluation)`
    `DefaultProductionNode(ReteContainer reteContainer, java.util.Map<java.lang.String,java.lang.Integer> posMapping, boolean deleteRederiveEvaluation, TupleMask coreMask, TupleMask posetMask, IPosetComparator posetComparator)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `acceptPropagatedTraceInfo(TraceInfo traceInfo)` accepts traceability info propagated to this node
    `java.util.Map<java.lang.String,java.lang.Integer>` | `getPosMapping()`
    `java.util.Iterator<Tuple>` | `iterator()`
    `java.lang.String` | `toString()`

    - ### Methods inherited from class org.eclipse.viatra.query.runtime.rete.single.UniquenessEnforcerNode

      `getCoreMask, getCurrentGroup, getIdentityIndexer, getNullIndexer, getPosetComparator, getPosetMask, getTuples, instantiateMailbox, isInDRedMode, pullInto, pullIntoWithTimeline, rederiveOne, setCurrentGroup, update, updateDefault, updateWithDeleteAndRederive, updateWithPosetInfo`

    - ### Methods inherited from class org.eclipse.viatra.query.runtime.rete.single.AbstractUniquenessEnforcerNode

      `appendParent, assignTraceInfo, constructIndex, getMailbox, getParents, propagate, removeParent`

    - ### Methods inherited from class org.eclipse.viatra.query.runtime.rete.network.StandardNode

      `appendChild, getChildMailboxes, getPulledContents, getReceivers, issueError, networkStructureChanged, propagateUpdate, removeChild`

    - ### Methods inherited from class org.eclipse.viatra.query.runtime.rete.network.BaseNode

      `getContainer, getNodeId, getTag, getTraceInfoPatternsEnumerated, getTraceInfos, setTag, toStringCore`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.eclipse.viatra.query.runtime.rete.network.Supplier

      `appendChild, constructIndex, getPulledContents, getPulledContents, getReceivers, pullInto, pullIntoWithTimeline, removeChild`

    - ### Methods inherited from interface org.eclipse.viatra.query.runtime.rete.network.Receiver

      `appendParent, batchUpdate, getMailbox, getParents, removeParent, update`

    - ### Methods inherited from interface org.eclipse.viatra.query.runtime.rete.network.Node

      `assignTraceInfo, getCommunicationTracker, getContainer, getNodeId, getTag, getTraceInfos, setTag`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach, spliterator`

- - ### Field Detail

    - #### posMapping

          protected final java.util.Map<java.lang.String,java.lang.Integer> posMapping

  - ### Constructor Detail

    - #### DefaultProductionNode

          public DefaultProductionNode(ReteContainer reteContainer,
                                       java.util.Map<java.lang.String,java.lang.Integer> posMapping,
                                       boolean deleteRederiveEvaluation)

      Since:
        1.6

    - #### DefaultProductionNode

          public DefaultProductionNode(ReteContainer reteContainer,
                                       java.util.Map<java.lang.String,java.lang.Integer> posMapping,
                                       boolean deleteRederiveEvaluation,
                                       TupleMask coreMask,
                                       TupleMask posetMask,
                                       IPosetComparator posetComparator)

      Since:
        1.6

  - ### Method Detail

    - #### getPosMapping

          public java.util.Map<java.lang.String,java.lang.Integer> getPosMapping()

      Specified by:
        `getPosMapping` in interface `ProductionNode`
      Returns:
        the position mapping of this particular pattern that maps members of the tuple type to their positions

    - #### iterator

          public java.util.Iterator<Tuple> iterator()

      Specified by:
        `iterator` in interface `java.lang.Iterable<Tuple>`

    - #### acceptPropagatedTraceInfo

          public void acceptPropagatedTraceInfo(TraceInfo traceInfo)

      Description copied from interface: `Node`
      accepts traceability info propagated to this node
      Specified by:
        `acceptPropagatedTraceInfo` in interface `Node`
      Overrides:
        `acceptPropagatedTraceInfo` in class `BaseNode`

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `BaseNode`